#include <stdio.h>
#include "parti.h"

/*=========================================================*/
void 
PREFIXgather(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{

  PARTI_gather(sched, data, target, sizeof(TYPE));

}

/*=========================================================*/
void 
PREFIXscatter(data,target,sched)
SCHED *sched;
TYPE  *data,*target;
{

  PARTI_scatter (sched, data, target, sizeof(TYPE), NULL);

}
/*=========================================================*/

void 
PREFIXscatter_add(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXadd);

}

/*=========================================================*/
void 
PREFIXscatter_sub(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXsub);
   
}
/*=========================================================*/
void 
PREFIXscatter_max(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXmax);
   
}
/*=========================================================*/
void 
PREFIXscatter_min(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXmin);
}
   
/*=========================================================*/
void 
PREFIXscatter_logior(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXlogior);
}
   
/*=========================================================*/
void 
PREFIXscatter_logand(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXlogand);
}
   
/*=========================================================*/
void 
PREFIXscatter_logxor(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXlogxor);
}
   
/*=========================================================*/
void 
PREFIXscatter_mult(data, target, sched)
SCHED *sched;
TYPE *data,*target;
{

  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXmul);
   
}
/*=========================================================*/

void 
PREFIXscatter_addnc(data, target, sched)
SCHED *sched;
TYPE  *data,*target;
{
    
  /* sched->type = NC; */
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXadd);
 
}
/*=========================================================*/

void 
PREFIXscatternc(data, target, sched)
SCHED *sched;
TYPE *data,*target;
{
    
  /* sched->type = NC; */
  PARTI_scatter (sched, data, target, sizeof(TYPE), NULL);
 
}
/*=========================================================*/

void 
PREFIXscatter_subnc(data, target, sched)
SCHED *sched;
TYPE *data,*target;
{
    
  /* sched->type = NC; */
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXsub);
 
}
/*=========================================================*/

void 
PREFIXscatter_multnc(data, target, sched)
SCHED *sched;
TYPE *data,*target;
{
    
  /* sched->type = NC; */
  PARTI_scatter (sched, data, target, sizeof(TYPE), PARTI_PREFIXmul);
 
}
/*=========================================================*/

void 
PREFIXscatter_append(data, target, sched)
SCHED *sched;
TYPE *data,*target;
{

  PARTI_scatter_append (sched, data, target, sizeof(TYPE));

}
/*=========================================================*/

/*----------------------------------------------------------------------*/
/* Functions for multidimentional arrays				*/
/*----------------------------------------------------------------------*/

void
PREFIXmultigather(data,target,n_scheds,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int  n_scheds;
int  base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,step,ccount,ii;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXgather");
#endif
  blist = (TYPE **) wbuffer->blist;
  ccount = 0;
  step = 0;
  while (ccount < n_scheds) {
      buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
      count = 0;
      for(i=0;i<PARTI_numnodes;i++){
         blist[i] = &buffer[count];
         count += sched[ccount]->sr->fetch_n[i]*repetition;
      }

      PREFIXmdexecute_gather(sched[ccount]->sr,blist,target,
                                          base_shift,dialation,repetition);

      for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
         data[base_shift*ii+step + sched[ccount]->perm[i]*dialation] = 
                                                     buffer[i*repetition+ii];
      step += sched[ccount]->ndata;

      free(buffer);
      ccount++;
  }

#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ccount,step,ii;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter");
#endif

  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    } 

    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition + ii] = 
                   data[base_shift*ii+step + sched[ccount]->perm[i]*dialation]; 

    PREFIXmdexecute_scatter(sched[ccount]->sr,blist,target,base_shift,
                                               dialation,repetition);
    step += sched[ccount]->ndata;

    free(buffer);
    ccount++;
  }

#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter_add(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXscatter_add");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_add(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter_sub(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_sub");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_sub(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter_mult(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,step,ccount;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_mult");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
      blist[i] = &buffer[count];
      count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
       for(ii=0;ii<repetition;ii++)
          buffer[i*repetition+ii] = 
                   data[base_shift*ii+step+sched[ccount]->perm[i]*dialation];
    
    PREFIXmdexecute_mult(sched[ccount]->sr,blist,target,base_shift,
                                                     dialation,repetition);
    step += sched[ccount]->ndata;
 
    free(buffer);
    ccount++;
  }
#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter_addnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_addnc");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_add(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
 
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}

/*=========================================================*/
void
PREFIXmultiscatternc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatternc");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_scatter(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
 
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/

void
PREFIXmultiscatter_subnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_subnc");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_sub(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
 
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}

/*=========================================================*/
void
PREFIXmultiscatter_multnc(data,target,n_sched,sched,base_shift,dialation,repetition)
TYPE *data,*target;
int n_sched;
int base_shift,dialation,repetition;
SCHED **sched;
{
  int count,i,ii,ccount,step;
  TYPE **blist,*buffer;

#ifdef DEBUG
  trace_enter("PREFIXmultiscatter_multnc");
#endif
  blist = (TYPE **) wbuffer->blist;
  step = 0;
  ccount = 0;
  while(ccount < n_sched){
    buffer = (TYPE *) malloc(sizeof(TYPE)*sched[ccount]->ndata*repetition);
    count = 0;
    for(i=0;i<PARTI_numnodes;i++){
       blist[i] = &buffer[count];
       count += sched[ccount]->sr->fetch_n[i]*repetition;
    }
    
    for(i=0;i<sched[ccount]->ndata;i++)
      for(ii=0;ii<repetition;ii++)
         buffer[i*repetition+ii] = data[base_shift*ii+
                  sched[ccount]->local_refs[sched[ccount]->perm[i]]*dialation];
                  
    
    PREFIXmdexecute_mult(sched[ccount]->sr,blist,target,base_shift,
                                                         dialation,repetition);
 
    ccount++;
  }
  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}
/*=========================================================*/
